//------------------------------------------------------------------
#property copyright "www.forex-tsd.com (Robertomar mod)"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window

//+------------------------------------------------------------------+
//| INCLUDES                                                                       |
//+------------------------------------------------------------------+
#include <Controls\Label.mqh>
//+------------------------------------------------------------------+
//| GLOBAL PARAMETERS AND VARIABLES                                                |
//+------------------------------------------------------------------+
MqlBookInfo       BookInfo[];
CLabel BidVolume;
CLabel AskVolume;
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| EXTERN VARIABLES                                                |
//+------------------------------------------------------------------+
extern string FileName   = "Ticks.csv";
extern bool   SaveVolume = false; 
int fileHandle;
//+------------------------------------------------------------------+

//+------------------------------------------------------------------+
//| ON INIT                                                                        |
//+------------------------------------------------------------------+


int  OnInit()                   { 
//--- Adding the DOM for the Symbol
   MarketBookAdd(_Symbol);
//--- Setting OnTimer interval
   EventSetMillisecondTimer(1);
//--- Creating ask volume label
   AskVolume.Create(0,"Ask volume",0,0,0,0,0);
//--- Creating bid volume label
   BidVolume.Create(0,"Bid volume",0,0,15,0,0);
//--- Setting initial values for bid and ask volumes
   MarketBookGet(NULL,BookInfo);
   for(int i=0;i<ArraySize(BookInfo)-1;i++)
     {
      if(BookInfo[i].type != BookInfo[i+1].type)
        {
         AskVolume.Text("Ask volume = "+BookInfo[i].volume);
         BidVolume.Text("Bid volume = "+BookInfo[i+1].volume);
        }
     }  

fileHandle = FileOpen(Symbol()+" - "+FileName,FILE_WRITE|FILE_SHARE_READ|FILE_ANSI|FILE_CSV); return(0); }

//+------------------------------------------------------------------+
//| ON DEINIT                                                                      |
//+------------------------------------------------------------------+
void OnDeinit(const int reason) {              FileClose(fileHandle);
//--- Libera o DOM do ativo
   MarketBookRelease(_Symbol);
//--- Apaga todos os objetos
   ObjectsDeleteAll(0,0);
//--- Remove timer
   EventKillTimer();
}

//+------------------------------------------------------------------+
//| ON TIMER                                                                       |
//+------------------------------------------------------------------+
void OnTimer()
{
//---
   MarketBookGet(NULL,BookInfo);
//---
   for(int i=0;i<ArraySize(BookInfo)-1;i++)
     {
      if(BookInfo[i].type != BookInfo[i+1].type)
        {
         AskVolume.Text("Ask volume = "+BookInfo[i].volume);
         BidVolume.Text("Bid volume = "+BookInfo[i+1].volume);
         }
     }

}

//+------------------------------------------------------------------+
//| ON CALCULATE                                                                       |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total, const int prev_calculated, const datetime &Time[],
                const double &Open[], const double &High[], const double &Low[], const double &Close[],
                const long &TickVolume[], const long &Volume[], const int &Spread[])
{                
   if (fileHandle <0)
   {
      static bool alerted = false;
         if (!alerted)
         {
            Alert("File : "+Symbol()+" - "+FileName+" could not be opened"); alerted = true;
         }
         return(0);
   }         
   if (FileSize(fileHandle) == 0)
   
   
         FileWriteString(fileHandle,"Timestamp,Bid Price,Ask Price,Bid Volume,Ask Volume\n");
         MarketBookGet(NULL,BookInfo);
         for(int i=0;i<ArraySize(BookInfo)-1;i++)
         
         if(BookInfo[i].type != BookInfo[i+1].type)
         {
         AskVolume.Text("Ask volume = "+BookInfo[i].volume);
         BidVolume.Text("Bid volume = "+BookInfo[i+1].volume);
         
         if (SaveVolume)
               FileWriteString(fileHandle,TimeToString(TimeCurrent(),TIME_DATE|TIME_SECONDS)+","+DoubleToString(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits)+","+DoubleToString(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits)+","+DoubleToString(TickVolume[rates_total],0)+"\n");     
         else  FileWriteString(fileHandle,TimeToString(TimeCurrent(),TIME_DATE|TIME_SECONDS)+","+DoubleToString(SymbolInfoDouble(_Symbol,SYMBOL_BID),_Digits)+","+DoubleToString(SymbolInfoDouble(_Symbol,SYMBOL_ASK),_Digits)+","+BookInfo[i+1].volume+","+BookInfo[i].volume+"\n");
         }
         FileFlush(fileHandle);
         
   
   return(0);
}